<script>
	import { hapiServerInfoCadences, hapiServerInfo, dataProductInfo, urlsToLoad } from '../stores/dataProductStore.js';
	import { layoutData } from '../stores/layoutStore.js';

	import { loadAll } from '@square/svelte-store'

	import ColorInput from  '../form_components/ColorInput.svelte';
	import TextInput from   '../form_components/TextInput.svelte';
	import SelectInput from '../form_components/SelectInput.svelte';
	import RangeSlider from '../form_components/RangeSlider.svelte';

	export let plotElement;
	export let subplot;
	export let subplot_index;
	export let plot_element_index;

	const set_zdomain = function(e, subplot_index, plot_element_index, min_or_max) {
		let value = e.srcElement.value;
		if (min_or_max == 'min') {
			$layoutData.subplots[subplot_index].plot_elements[plot_element_index].plot_options.color_scale_domain.default[0] = value;
		} else {
			$layoutData.subplots[subplot_index].plot_elements[plot_element_index].plot_options.color_scale_domain.default[1] = value;
		}
	}

</script>

<h4 id="{plot_element_index}">Plot element: {plotElement.parameter}</h4>
<TextInput id="server_{subplot_index}_{plot_element_index}" titleText="Server" bind:value={plotElement.server}/>
{#await hapiServerInfoCadences.load()}
	<SelectInput titleText="Dataset ID" bind:value={plotElement.dataset}>
		<option value={plotElement.dataset} selected>{plotElement.dataset}</option>
	</SelectInput>
{:then serverInfo}
	<SelectInput titleText="Dataset ID" bind:value={plotElement.dataset}>
		{#each Object.keys(serverInfo[plotElement.server]).sort() as product}
			{#if (product == plotElement.dataset)}
				<option value={product} selected>{product}</option>
			{:else}
				<option value={product}>{product}</option>
			{/if}
		{/each}
	</SelectInput>
{/await}
{#await dataProductInfo.load()}
	<SelectInput titleText="Parameter" bind:value={plotElement.parameter}>
		<option value={plotElement.parameter} selected>{plotElement.parameter}</option>
	</SelectInput>
{:then productInfo}
	<SelectInput titleText="Parameter" bind:value={plotElement.parameter}>
		{#if plotElement.dataset in productInfo}
			{#each productInfo[plotElement.dataset].parameters as parameter}
				{#if (parameter == plotElement.parameter)}
					<option value={parameter} selected>{parameter}</option>
				{:else}
					<option value={parameter}>{parameter}</option>
				{/if}
			{/each}
		{/if}
	</SelectInput>
{/await}


<!-- {#await urlsToLoad.load()}
{:then}
	<SelectInput titleText="Cadence">
		<option value={$urlsToLoad[plotElement.dataset]['cadence']['cadence_string']} selected>{$urlsToLoad[plotElement.dataset]['cadence']['cadence_string']}</option>
	</SelectInput>
{/await} -->

<div style="height: 20px;"></div>

{#if "fill" in plotElement.plot_options}
	<ColorInput titleText="Fill" bind:colorvalue={$layoutData.subplots[subplot_index].plot_elements[plot_element_index]['plot_options']['fill']} bind:opacityvalue={$layoutData.subplots[subplot_index].plot_elements[plot_element_index]['plot_options']['fill-opacity']}/>
{/if}
{#if "stroke" in plotElement.plot_options}
	<ColorInput titleText="Stroke colour" bind:colorvalue={$layoutData.subplots[subplot_index].plot_elements[plot_element_index]['plot_options']['stroke']} bind:opacityvalue={$layoutData.subplots[subplot_index].plot_elements[plot_element_index]['plot_options']['stroke-opacity']}/>
	<RangeSlider titleText="Stroke width"
				 fill="fillfromleft"
				 min=0
				 max=5
				 step=0.25
				 id="subplot_{subplot.subplot_id}_stroke"
				 bind:value="{$layoutData.subplots[subplot_index].plot_elements[plot_element_index]['plot_options']['stroke-width']}"/>

{/if}
{#if "color_scale_domain" in plotElement.plot_options}
	{#if !subplot.ydomain.mirror}
		<RangeSlider titleText="Colour scale max"
	 				fill="fillfromleft"
	 				min={plotElement.plot_options.color_scale_domain.range_extent[0]}
	 				max={plotElement.plot_options.color_scale_domain.range_extent[1]}
	 				step=0.01
	 				id="plotElement_{plotElement.id}_yaxismax"
	 				value={plotElement.plot_options.color_scale_domain.default[1]}
	 				oninput={ (e) => { set_zdomain(e, subplot_index, plot_element_index, 'max') } }/>
	{/if}
		<RangeSlider titleText="Colour scale min"
	 				fill="fillfromright"
	 				min={plotElement.plot_options.color_scale_domain.range_extent[0]}
	 				max={plotElement.plot_options.color_scale_domain.range_extent[1]}
	 				step=0.01
	 				id="plotElement_{plotElement.id}_yaxismin"
	 				value={plotElement.plot_options.color_scale_domain.default[0]}
	 				oninput={ (e) => { set_zdomain(e, subplot_index, plot_element_index, 'min') } }/>
{/if}

<style>
	h4{
		text-align: right;
		font-size: 10pt;
	}
</style>